(function() {
  var Yadda, converters, cson, cstype_convert, str_convert;

  Yadda = require('yadda');

  cson = require('../cson-string');

  converters = Yadda.converters;

  str_convert = function(value, next) {
    var delimiter;
    delimiter = value[0];
    value = value.slice(1, value.length - 1);
    console;
    if (delimiter === '`') {
      return cstype_convert(value, next);
    } else {
      return next(null, value);
    }
  };

  cstype_convert = function(value, next) {
    var err, error;
    try {
      value = cson(value);
      return next(null, value);
    } catch (error) {
      err = error;
      return next(err);
    }
  };

  module.exports = function(aDictionary) {
    return aDictionary.define('string', /(".+"|'.+'|“.+”|‘.+’|`.+`)/, str_convert).define('identifier', /([\w\x7f-\ufaff]+)/).define('object', /([^\u0000]*)/, cstype_convert).define('list', /([^\u0000]*)/, converters.list).define('table', /([^\u0000]*)/, converters.table).define('integer', /(\d+)/, converters.integer).define('int', /(\d+)/, converters.integer).define('float', /([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)/, converters.float).define('date', /(\d{4}-\d{1,2}-\d{1,2}(?:T\d{2}:\d{2}:\d{2}Z)?)/, converters.date);
  };

}).call(this);

//# sourceMappingURL=main-dict.js.map
